/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_peephole2_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_10 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_11 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_12 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_10 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_11 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_12 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_13 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_14 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_15 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_16 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_17 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_18 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_19 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_20 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_21 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arith11_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != FIX)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1 (x2, E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1 (x2, E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  if (!register_operand (operands[6], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[7] = x9;
  if (!register_operand (operands[7], E_SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  x11 = XEXP (x10, 0);
  operands[8] = x11;
  if (!register_operand (operands[8], E_SImode))
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!arith14_operand (operands[4], E_SImode))
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  x15 = XEXP (x14, 0);
  operands[5] = x15;
  if (!const_int_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != USE)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != USE)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x11 = XEXP (x2, 1);
  operands[1] = x11;
  if (!memory_operand (operands[1], E_BLKmode)
      || pattern3 (x1) != 0)
    return -1;
  return 0;
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 19
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  return 0;
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER
      || pattern5 (x1) != 0)
    return -1;
  return 0;
}

static int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      return pattern7 (x1, E_DFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern7 (x1, E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CALL:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != MEM
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case SET:
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != CALL)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern11 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

static int
pattern12 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case TRAP_IF:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != NE)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != i1)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTEND)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x2, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      operands[1] = x13;
      x14 = XEXP (x12, 1);
      operands[2] = x14;
      x15 = XEXP (x5, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x6, 0);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      x17 = XEXP (x8, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x8, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          return 0;

        case E_SImode:
          return 1;

        default:
          return -1;
        }

    case SET:
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != MULT)
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_VOIDmode))
        return -1;
      x14 = XEXP (x12, 1);
      operands[5] = x14;
      if (!register_operand (operands[5], E_VOIDmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x19 = XEXP (x9, 0);
      operands[1] = x19;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x20 = XEXP (x9, 1);
      operands[2] = x20;
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern13 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC_VOLATILE
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

static int
pattern14 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 26
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 29
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x3, 1);
  operands[0] = x8;
  if (!div_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x7, 0);
  operands[2] = x10;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern15 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 26
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 25
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 29
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x7, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x10 = XEXP (x8, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

static int
pattern16 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

static int
pattern17 (rtx x1, unsigned int i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern16 (x4, i2, i3); /* [-1, 0] */
}

static int
pattern18 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!reg_or_0_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  if (!arith5_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  return 0;
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!uint5_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 2);
  operands[3] = x5;
  if (!uint5_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

static int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 26
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 25
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

static int
pattern23 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  return 0;
}

static int
pattern24 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  return 0;
}

static int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

static int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CONST_INT:
      operands[2] = x1;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case MINUS:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != USE)
    return -1;
  return 0;
}

static int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1
      || GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

static int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 26
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 29
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 26
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 25
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 31
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XEXP (x3, 1);
  operands[0] = x12;
  if (!div_operand (operands[0], E_SImode))
    return -1;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  x16 = XEXP (x15, 0);
  operands[2] = x16;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 26
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 25
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 29
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 25
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 31
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[0] = x14;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  x16 = XEXP (x15, 0);
  operands[1] = x16;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

static int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x8 = XEXP (x3, 2);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XEXP (x2, 0);
  if (GET_CODE (x9) != PC)
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PLUS
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

static int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != MINUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
      || pattern17 (x1, 25, 2, CLOBBER) != 0)
    return -1;
  return 0;
}

static int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[1] = x6;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!uint5_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x1, 1);
      switch (GET_CODE (x7))
        {
        case LABEL_REF:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          return 0;

        case PC:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x1, 1);
      switch (GET_CODE (x7))
        {
        case LABEL_REF:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          return 2;

        case PC:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern36 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != ABS)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x2, 0);
  operands[2] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      return pattern37 (x1, E_DFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern37 (x1, E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      return pattern39 (x1, E_DFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern39 (x1, E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != MINUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 25
      || GET_MODE (x8) != E_SImode)
    return -1;
  return 0;
}

static int
pattern42 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 26
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

static int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!arith14_operand (operands[2], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

static int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], E_BLKmode)
      || pattern45 (x1) != 0)
    return -1;
  return 0;
}

static int
pattern47 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

static int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith14_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern49 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != i2)
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern50 (rtx x1, rtx_code i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern51 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 29
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 31
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

static int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x5;
      if (!call_operand_address (operands[1], E_VOIDmode))
        return -1;
      return 0;

    case REG:
      if (REGNO (x5) != 22
          || GET_MODE (x5) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

static int
pattern54 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 19
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

static int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 2
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case USE:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 2
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!pmode_register_operand (operands[0], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!pmode_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!pmode_register_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!pmode_register_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!pmode_register_operand (operands[4], E_VOIDmode))
    return -1;
  return 0;
}

static int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[0], i1)
      || !scratch_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern58 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

static int
pattern59 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern60 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !arith11_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  return pattern59 (x5, i1, i2); /* [-1, 0] */
}

static int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[0] = x4;
      if (!call_operand_address (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      x6 = XEXP (x5, 0);
      if (XWINT (x6, 0) != 0L)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      return 0;

    case REG:
      if (REGNO (x4) != 22
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      x6 = XEXP (x5, 0);
      if (XWINT (x6, 0) != 1L)
        return -1;
      x7 = XEXP (x2, 1);
      operands[0] = x7;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      return 1;

    default:
      return -1;
    }
}

static int
pattern62 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !arith11_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  return pattern59 (x5, i1, i2); /* [-1, 0] */
}

static int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x6;
      if (!call_operand_address (operands[1], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x1, 0, 5);
      x8 = XEXP (x7, 0);
      if (XWINT (x8, 0) != 0L)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      return 0;

    case REG:
      if (REGNO (x6) != 22
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 5);
      x8 = XEXP (x7, 0);
      if (XWINT (x8, 0) != 1L)
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      return 1;

    default:
      return -1;
    }
}

static int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 19
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!reg_or_cint_move_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!arith11_operand (operands[4], E_SImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          operands[2] = x5;
          return 28; /* *pa.md:1264 */
        }
      operands[5] = x5;
      operands[2] = x8;
      if (!reg_or_cint_move_operand (operands[2], E_SImode))
        return -1;
      return 29; /* *pa.md:1281 */

    case LABEL_REF:
      if (pattern18 (x1, PC) != 0)
        return -1;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      return 30; /* *pa.md:1413 */

    case PC:
      if (pattern18 (x1, LABEL_REF) != 0)
        return -1;
      x8 = XEXP (x2, 2);
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      return 31; /* *pa.md:1442 */

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x4, 0);
  operands[0] = x8;
  x9 = XEXP (x6, 0);
  operands[1] = x9;
  switch (XWINT (x5, 0))
    {
    case 4L:
      if (pattern53 (x2, E_SImode) != 0)
        return -1;
      if (
#line 7254 "../../gcc/config/pa/pa.md"
(!flag_pic))
        {
          *pnum_clobbers = 1;
          return 203; /* casesi32 */
        }
      if (!
#line 7267 "../../gcc/config/pa/pa.md"
(flag_pic))
        return -1;
      *pnum_clobbers = 2;
      return 204; /* casesi32p */

    case 8L:
      if (pattern53 (x2, E_DImode) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 205; /* casesi64p */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 0
          && GET_MODE (x3) == E_CCFPmode)
        {
          switch (XWINT (x2, 0))
            {
            case 0L:
              if (
#line 740 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return 3; /* *movccfp0 */
              break;

            case 1L:
              if (
#line 748 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return 4; /* *movccfp1 */
              break;

            default:
              break;
            }
        }
      break;

    case REG:
    case SUBREG:
      operands[0] = x2;
      if (pmode_register_operand (operands[0], E_VOIDmode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            return 201; /* indirect_jump */
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!uint5_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!uint5_operand (operands[2], E_SImode))
    return -1;
  if (arith5_operand (operands[3], E_SImode)
      && 
#line 9198 "../../gcc/config/pa/pa.md"
(UINTVAL (operands[1]) > 0
   && UINTVAL (operands[1]) + UINTVAL (operands[2]) <= 32))
    return 231; /* insv_32 */
  if (!const_int_operand (operands[3], E_SImode)
      || !
#line 9212 "../../gcc/config/pa/pa.md"
((INTVAL (operands[3]) & 0x10) != 0 &&
   (~INTVAL (operands[3]) & ((1L << INTVAL (operands[1])) - 1) & ~0xf) == 0))
    return -1;
  return 232; /* *pa.md:9207 */
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case MEM:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case REG:
    case SUBREG:
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (move_dest_operand (operands[0], E_SImode)
          && move_src_operand (operands[1], E_SImode))
        {
          if (
#line 2190 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && !TARGET_SOFT_FLOAT
   && !TARGET_64BIT))
            return 42; /* *pa.md:2185 */
          if (
#line 2218 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && !TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 43; /* *pa.md:2213 */
          if (
#line 2244 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 44; /* *pa.md:2239 */
        }
      if (indexed_memory_operand (operands[0], E_SImode)
          && register_operand (operands[1], E_SImode)
          && 
#line 2265 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return 45; /* *pa.md:2262 */
      if (!move_dest_operand (operands[0], E_SImode)
          || !move_src_operand (operands[1], E_SImode)
          || !
#line 2385 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && TARGET_SOFT_FLOAT))
        return -1;
      return 46; /* *pa.md:2380 */

    case E_HImode:
      if (!move_dest_operand (operands[0], E_HImode)
          || !move_src_operand (operands[1], E_HImode)
          || !
#line 2913 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))))
        return -1;
      return 61; /* *pa.md:2908 */

    case E_QImode:
      if (!move_dest_operand (operands[0], E_QImode)
          || !move_src_operand (operands[1], E_QImode)
          || !
#line 3073 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))))
        return -1;
      return 66; /* *pa.md:3068 */

    case E_DFmode:
      if (move_dest_operand (operands[0], E_DFmode)
          && reg_or_0_or_nonsymb_mem_operand (operands[1], E_DFmode)
          && 
#line 3861 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && !(GET_CODE (operands[1]) == CONST_DOUBLE
	&& GET_CODE (operands[0]) == MEM)
   && !TARGET_64BIT
   && !TARGET_SOFT_FLOAT))
        return 75; /* *pa.md:3856 */
      if (indexed_memory_operand (operands[0], E_DFmode)
          && reg_or_0_operand (operands[1], E_DFmode)
          && 
#line 3882 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return 76; /* *pa.md:3879 */
      if (!move_dest_operand (operands[0], E_DFmode))
        return -1;
      if (reg_or_0_or_nonsymb_mem_operand (operands[1], E_DFmode)
          && 
#line 4035 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && !TARGET_64BIT
   && TARGET_SOFT_FLOAT))
        return 77; /* *pa.md:4030 */
      if (!move_src_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 4051 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && !TARGET_SOFT_FLOAT && TARGET_64BIT))
        return 78; /* *pa.md:4046 */
      if (!
#line 4073 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && TARGET_SOFT_FLOAT && TARGET_64BIT))
        return -1;
      return 79; /* *pa.md:4068 */

    case E_DImode:
      if (!move_dest_operand (operands[0], E_DImode)
          || !move_src_operand (operands[1], E_DImode))
        return -1;
      if (
#line 4203 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_64BIT
   && !TARGET_SOFT_FLOAT))
        return 81; /* *pa.md:4198 */
      if (
#line 4225 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_SOFT_FLOAT && TARGET_64BIT))
        return 82; /* *pa.md:4220 */
      if (!
#line 4250 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && TARGET_SOFT_FLOAT && TARGET_64BIT))
        return -1;
      return 83; /* *pa.md:4245 */

    case E_SFmode:
      if (move_dest_operand (operands[0], E_SFmode)
          && reg_or_0_or_nonsymb_mem_operand (operands[1], E_SFmode))
        {
          if (
#line 4435 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && !TARGET_SOFT_FLOAT
   && !TARGET_64BIT))
            return 86; /* *pa.md:4430 */
          if (
#line 4457 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && !TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 87; /* *pa.md:4452 */
          if (
#line 4477 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 88; /* *pa.md:4472 */
        }
      if (indexed_memory_operand (operands[0], E_SFmode)
          && register_operand (operands[1], E_SFmode)
          && 
#line 4492 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return 89; /* *pa.md:4489 */
      if (!move_dest_operand (operands[0], E_SFmode)
          || !reg_or_0_or_nonsymb_mem_operand (operands[1], E_SFmode)
          || !
#line 4610 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && TARGET_SOFT_FLOAT))
        return -1;
      return 90; /* *pa.md:4605 */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (
#line 2698 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[1], Pmode)
   && ! function_label_operand (operands[1], Pmode)
   && ! read_only_operand (operands[1], Pmode)
   && ! flag_pic))
        return 57; /* *pa.md:2695 */
      if (!
#line 2746 "../../gcc/config/pa/pa.md"
((!flag_pic || !symbolic_operand (operands[1], Pmode))
    && !pa_is_function_label_plus_const (operands[1])))
        return -1;
      return 59; /* *pa.md:2743 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 80; /* *pa.md:4148 */

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[3] = x3;
      if (!ordered_comparison_operator (operands[3], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      if (!ordered_comparison_operator (x4, E_SImode))
        return -1;
      operands[6] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!arith11_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[4] = x7;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[5] = x8;
      if (!arith11_operand (operands[5], E_SImode))
        return -1;
      return 6; /* iorscc */

    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          if (!cint_ior_operand (operands[2], E_SImode))
            return -1;
          return 137; /* *pa.md:5846 */

        case REG:
        case SUBREG:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 138; /* *pa.md:5855 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern26 (x2) != 0
          || !
#line 6497 "../../gcc/config/pa/pa.md"
(exact_log2 (INTVAL (operands[1]) + 1) > 0))
        return -1;
      return 181; /* vdepi_ior */

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      if (GET_MODE (x3) == E_SImode)
        {
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (register_operand (operands[2], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (register_operand (operands[1], E_SImode))
                {
                  switch (GET_CODE (x3))
                    {
                    case LEU:
                      if (arith11_operand (operands[3], E_SImode))
                        return 8; /* *pa.md:840 */
                      break;

                    case GEU:
                      if (register_operand (operands[3], E_SImode))
                        return 9; /* *pa.md:862 */
                      break;

                    case GTU:
                      if (int11_operand (operands[3], E_SImode))
                        return 10; /* *pa.md:885 */
                      break;

                    default:
                      break;
                    }
                }
            }
        }
      operands[4] = x3;
      if (!ordered_comparison_operator (operands[4], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!arith11_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 11; /* incscc */

    case REG:
    case SUBREG:
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case HIGH:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern47 (x2, E_SImode) != 0)
                return -1;
              if (
#line 2650 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && flag_pic))
                return 53; /* *pa.md:2646 */
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 2725 "../../gcc/config/pa/pa.md"
(reload_completed))
                return -1;
              return 58; /* *pa.md:2721 */

            case E_DImode:
              if (pattern47 (x2, E_DImode) != 0
                  || !
#line 2661 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && TARGET_64BIT
   && flag_pic))
                return -1;
              return 54; /* *pa.md:2657 */

            default:
              return -1;
            }

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern48 (x2, E_HImode) != 0)
                return -1;
              return 65; /* addhi3 */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !arith11_operand (operands[2], E_DImode))
                return -1;
              return 117; /* *pa.md:5014 */

            case E_SImode:
              if (pattern48 (x2, E_SImode) != 0)
                return -1;
              return 120; /* addsi3 */

            case E_DFmode:
              if (pattern7 (x2, E_DFmode) != 0
                  || !
#line 5999 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 146; /* adddf3 */

            case E_SFmode:
              if (pattern7 (x2, E_SFmode) != 0
                  || !
#line 6009 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 147; /* addsf3 */

            default:
              return -1;
            }

        case MINUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != LABEL_REF
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          return 196; /* load_offset_label_address */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 118; /* *pa.md:5055 */

    case ASHIFT:
      if (pattern20 (x2) != 0
          || !shadd_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 176; /* *pa.md:6375 */

    case MULT:
      if (pattern20 (x2) != 0
          || !mem_shadd_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 177; /* *pa.md:6385 */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x3, 0) != 1
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XVECEXP (x3, 0, 0);
      operands[1] = x10;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 6:
          if (!tld_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          *pnum_clobbers = 1;
          return 257; /* tld_offset_load */

        case 9:
          if (!tle_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          *pnum_clobbers = 1;
          return 261; /* tle_load */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (GET_MODE (x5) == E_SImode)
            {
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (register_operand (operands[2], E_SImode))
                {
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  switch (GET_CODE (x5))
                    {
                    case GTU:
                      if (arith11_operand (operands[3], E_SImode))
                        return 12; /* *pa.md:931 */
                      break;

                    case LTU:
                      if (register_operand (operands[3], E_SImode))
                        return 14; /* *pa.md:975 */
                      break;

                    case LEU:
                      if (int11_operand (operands[3], E_SImode))
                        return 16; /* *pa.md:1020 */
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[4] = x5;
          if (!ordered_comparison_operator (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          if (!arith11_operand (operands[3], E_SImode))
            return -1;
          return 18; /* decscc */

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !arith11_operand (operands[1], E_DImode)
                  || !reg_or_0_operand (operands[2], E_DImode))
                return -1;
              return 122; /* *pa.md:5229 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !arith11_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              if (
#line 5325 "../../gcc/config/pa/pa.md"
(!TARGET_PA_20))
                return 124; /* *pa.md:5321 */
              if (!
#line 5336 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
                return -1;
              return 125; /* *pa.md:5332 */

            case E_DFmode:
              if (pattern7 (x3, E_DFmode) != 0
                  || !
#line 6019 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 148; /* subdf3 */

            case E_SFmode:
              if (pattern7 (x3, E_SFmode) != 0
                  || !
#line 6029 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 149; /* subsf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pattern11 (x3, E_SImode) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      switch (GET_CODE (x8))
        {
        case GTU:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (!arith11_operand (operands[3], E_SImode))
            return -1;
          return 13; /* *pa.md:951 */

        case LTU:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 15; /* *pa.md:995 */

        case LEU:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (!int11_operand (operands[3], E_SImode))
            return -1;
          return 17; /* *pa.md:1040 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      if (GET_MODE (x3) == E_SImode
          && register_operand (operands[0], E_SImode))
        {
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_SImode))
                return 139; /* xorsi3 */
            }
        }
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_SImode)
      || !plus_xor_ior_operator (x3, E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      if (GET_CODE (x5) != LSHIFTRT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case MINUS:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          operands[4] = x3;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          return 186; /* *shrpsi4_1 */

        case CONST_INT:
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          operands[5] = x3;
          x11 = XEXP (x5, 1);
          operands[4] = x11;
          if (!const_int_operand (operands[4], E_SImode)
              || !
#line 6921 "../../gcc/config/pa/pa.md"
(INTVAL (operands[3]) + INTVAL (operands[4]) == 32))
            return -1;
          return 190; /* *pa.md:6914 */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_CODE (x5) != ASHIFT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x5, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          operands[4] = x3;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          return 187; /* *shrpsi4_2 */

        case CONST_INT:
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          operands[5] = x3;
          x11 = XEXP (x5, 1);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_SImode)
              || !
#line 6933 "../../gcc/config/pa/pa.md"
(INTVAL (operands[3]) + INTVAL (operands[4]) == 32))
            return -1;
          return 191; /* *pa.md:6926 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[3] = x4;
      if (!ordered_comparison_operator (operands[3], E_SImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith11_operand (operands[2], E_SImode))
        return -1;
      return 7; /* negscc */

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 140; /* *pa.md:5895 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 142; /* negsi2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 6092 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && !TARGET_PA_20))
            return 154; /* negdf2_slow */
          if (!
#line 6109 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
            return -1;
          return 155; /* negdf2_fast */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 6135 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && !TARGET_PA_20))
            return 156; /* negsf2_slow */
          if (!
#line 6143 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
            return -1;
          return 157; /* negsf2_fast */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern25 (x3, E_DFmode) != 0
              || !
#line 6234 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 166; /* *pa.md:6231 */

        case E_SFmode:
          if (pattern25 (x3, E_SFmode) != 0
              || !
#line 6242 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 167; /* *pa.md:6239 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern34 (x3, E_DFmode) != 0
              || !
#line 6291 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
            return -1;
          return 170; /* *pa.md:6287 */

        case E_SFmode:
          if (pattern34 (x3, E_SFmode) != 0
              || !
#line 6300 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
            return -1;
          return 171; /* *pa.md:6296 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST:
    case LABEL_REF:
      operands[1] = x2;
      if (pic_label_operand (operands[1], E_VOIDmode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (pmode_register_operand (operands[0], E_VOIDmode))
            {
              if (
#line 2556 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
                return 51; /* *pa.md:2553 */
              if (
#line 2606 "../../gcc/config/pa/pa.md"
(!TARGET_PA_20))
                return 52; /* *pa.md:2603 */
            }
        }
      if (GET_CODE (x2) == LABEL_REF)
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 200; /* jump */
            }
        }
      break;

    case HIGH:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (general_operand (operands[1], E_DImode))
    {
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (move_dest_operand (operands[0], E_DImode)
          && 
#line 4338 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_64BIT
   && TARGET_SOFT_FLOAT))
        return 84; /* *pa.md:4333 */
    }
  if (pnum_clobbers != NULL
      && reg_or_0_operand (operands[1], E_DImode))
    {
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == MEM
          && GET_MODE (x3) == E_DImode)
        {
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          if (register_operand (operands[0], E_SImode)
              && 
#line 10320 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT))
            {
              *pnum_clobbers = 1;
              return 263; /* atomic_storedi_1 */
            }
        }
    }
  if (pnum_clobbers == NULL
      || GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode)
      || !
#line 10279 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT))
    return -1;
  *pnum_clobbers = 1;
  return 262; /* atomic_loaddi_1 */
}

static int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 23; /* absqi2 */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 24; /* abshi2 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 25; /* abssi2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 6157 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 158; /* absdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 6165 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 159; /* abssf2 */

    default:
      return -1;
    }
}

static int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 4822 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 99; /* *pa.md:4819 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 4841 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 101; /* *pa.md:4838 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern19 (x3, E_SFmode))
            {
            case 0:
              if (!
#line 4830 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 100; /* floatsisf2 */

            case 1:
              if (!
#line 4893 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 103; /* floatdisf2 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern19 (x3, E_DFmode))
            {
            case 0:
              if (!
#line 4849 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 102; /* floatsidf2 */

            case 1:
              if (!
#line 4901 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 104; /* floatdidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      if (ordered_comparison_operator (x3, E_VOIDmode))
        {
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      switch (GET_CODE (x3))
        {
        case NE:
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              switch (pattern35 (x2))
                {
                case 0:
                  return 32; /* *pa.md:1581 */

                case 1:
                  return 33; /* *pa.md:1637 */

                case 2:
                  return 36; /* *pa.md:1806 */

                case 3:
                  return 37; /* *pa.md:1862 */

                default:
                  return -1;
                }

            case REG:
              if (REGNO (x6) != 0
                  || GET_MODE (x6) != E_CCFPmode)
                return -1;
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) != PC)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!
#line 2039 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
                    return -1;
                  return 40; /* *pa.md:2035 */

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) != LABEL_REF)
                    return -1;
                  x10 = XEXP (x8, 0);
                  operands[0] = x10;
                  if (!
#line 2083 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
                    return -1;
                  return 41; /* *pa.md:2079 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != ZERO_EXTRACT)
            return -1;
          switch (pattern35 (x2))
            {
            case 0:
              return 34; /* *pa.md:1693 */

            case 1:
              return 35; /* *pa.md:1749 */

            case 2:
              return 38; /* *pa.md:1918 */

            case 3:
              return 39; /* *pa.md:1974 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!ordered_comparison_operator (operands[2], E_VOIDmode)
      || pattern32 (x1) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!reg_before_reload_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  if (!int5_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[0]))
    return -1;
  x13 = XEXP (x11, 1);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x10, 0);
  if (!rtx_equal_p (x14, operands[0]))
    return -1;
  *pnum_clobbers = 1;
  return 233; /* decrement_and_branch_until_zero */
}

static int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x7, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x12 = XEXP (x6, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !pre_cint_operand (operands[2], E_SImode))
                return -1;
              return 47; /* pre_ldw */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !int5_operand (operands[2], E_SImode))
                return -1;
              return 62; /* *pa.md:2928 */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !int5_operand (operands[2], E_SImode))
                return -1;
              return 67; /* *pa.md:3088 */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x13 = XEXP (x5, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || GET_MODE (x3) != E_SImode)
            return -1;
          x14 = XEXP (x5, 0);
          operands[0] = x14;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x15 = XEXP (x9, 0);
          operands[1] = x15;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 7254 "../../gcc/config/pa/pa.md"
(!flag_pic))
            return -1;
          return 203; /* casesi32 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case SET:
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x11 = XEXP (x7, 1);
          operands[2] = x11;
          if (!post_cint_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x12 = XEXP (x6, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          return 49; /* *pa.md:2489 */

        case CLOBBER:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_DImode)
              || !
#line 10279 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT))
            return -1;
          return 262; /* atomic_loaddi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case MEM:
          return recog_16 (x1, insn, pnum_clobbers);

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case MEM:
              x5 = XEXP (x4, 0);
              switch (GET_CODE (x5))
                {
                case PLUS:
                  if (GET_MODE (x5) != E_SImode)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != SET)
                    return -1;
                  x7 = XEXP (x6, 1);
                  if (GET_CODE (x7) != PLUS
                      || GET_MODE (x7) != E_SImode)
                    return -1;
                  x8 = XEXP (x5, 0);
                  operands[0] = x8;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x9 = XEXP (x5, 1);
                  operands[1] = x9;
                  operands[2] = x3;
                  x10 = XEXP (x7, 0);
                  if (!rtx_equal_p (x10, operands[0]))
                    return -1;
                  x11 = XEXP (x7, 1);
                  if (!rtx_equal_p (x11, operands[1]))
                    return -1;
                  x12 = XEXP (x6, 0);
                  if (!rtx_equal_p (x12, operands[0]))
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_SImode:
                      if (!pre_cint_operand (operands[1], E_SImode)
                          || !reg_or_0_operand (operands[2], E_SImode))
                        return -1;
                      return 48; /* *pa.md:2473 */

                    case E_HImode:
                      if (!int5_operand (operands[1], E_SImode)
                          || !reg_or_0_operand (operands[2], E_HImode))
                        return -1;
                      return 64; /* *pa.md:2990 */

                    case E_QImode:
                      if (!int5_operand (operands[1], E_SImode)
                          || !reg_or_0_operand (operands[2], E_QImode))
                        return -1;
                      return 70; /* *pa.md:3164 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[0] = x5;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[1] = x3;
                  x6 = XVECEXP (x1, 0, 1);
                  switch (GET_CODE (x6))
                    {
                    case SET:
                      x7 = XEXP (x6, 1);
                      if (GET_CODE (x7) != PLUS
                          || GET_MODE (x7) != E_SImode
                          || GET_MODE (x4) != E_SImode
                          || !reg_or_0_operand (operands[1], E_SImode))
                        return -1;
                      x11 = XEXP (x7, 1);
                      operands[2] = x11;
                      if (!post_cint_operand (operands[2], E_SImode))
                        return -1;
                      x10 = XEXP (x7, 0);
                      if (!rtx_equal_p (x10, operands[0]))
                        return -1;
                      x12 = XEXP (x6, 0);
                      if (!rtx_equal_p (x12, operands[0]))
                        return -1;
                      return 50; /* post_stw */

                    case CLOBBER:
                      if (GET_MODE (x4) != E_DImode
                          || !reg_or_0_operand (operands[1], E_DImode))
                        return -1;
                      x12 = XEXP (x6, 0);
                      operands[2] = x12;
                      if (!scratch_operand (operands[2], E_DImode)
                          || !
#line 10320 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT))
                        return -1;
                      return 263; /* atomic_storedi_1 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case PC:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern9 (x6, 2, CLOBBER) != 0)
                return -1;
              operands[0] = x3;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              if (
#line 8892 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && !TARGET_64BIT))
                return 224; /* *pa.md:8889 */
              if (
#line 8900 "../../gcc/config/pa/pa.md"
(TARGET_NO_SPACE_REGS && !TARGET_64BIT))
                return 225; /* *pa.md:8897 */
              return 226; /* *pa.md:8905 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x13 = XEXP (x3, 0);
          if (GET_CODE (x13) != MEM)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x16 = XEXP (x14, 1);
          operands[2] = x16;
          if (!int5_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x7, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x12 = XEXP (x6, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x13))
                {
                case E_HImode:
                  return 63; /* *pa.md:2964 */

                case E_QImode:
                  return 68; /* *pa.md:3120 */

                default:
                  return -1;
                }

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || GET_MODE (x13) != E_QImode)
                return -1;
              return 69; /* *pa.md:3142 */

            default:
              return -1;
            }

        case PLUS:
          x13 = XEXP (x3, 0);
          switch (GET_CODE (x13))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case REG:
            case SUBREG:
              switch (pattern12 (x1, PLUS))
                {
                case 0:
                  if (pattern62 (x1, E_DImode, E_TImode) != 0)
                    return -1;
                  return 119; /* *pa.md:5092 */

                case 1:
                  if (pattern62 (x1, E_SImode, E_DImode) != 0)
                    return -1;
                  return 121; /* addvsi3 */

                case 2:
                  if (!
#line 9678 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpyaddoperands (operands)))
                    return -1;
                  return 242; /* *pa.md:9671 */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x13, 0) != 1)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern9 (x6, 1, CLOBBER) != 0)
                return -1;
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x17 = XVECEXP (x13, 0, 0);
              operands[1] = x17;
              x18 = XEXP (x3, 1);
              operands[2] = x18;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              switch (XINT (x13, 1))
                {
                case 6:
                  if (!tld_symbolic_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 257; /* tld_offset_load */

                case 9:
                  if (!tle_symbolic_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 261; /* tle_load */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          switch (pattern12 (x1, MINUS))
            {
            case 0:
              if (pattern60 (x1, E_DImode, E_TImode) != 0)
                return -1;
              return 123; /* *pa.md:5283 */

            case 1:
              if (pattern60 (x1, E_SImode, E_DImode) != 0)
                return -1;
              return 126; /* subvsi3 */

            case 2:
              if (!
#line 9726 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpysuboperands (operands)))
                return -1;
              return 244; /* *pa.md:9719 */

            default:
              return -1;
            }

        case MULT:
          if (pnum_clobbers != NULL
              && pattern22 (x3) == 0)
            {
              x4 = XEXP (x2, 0);
              if (GET_CODE (x4) == REG
                  && REGNO (x4) == 29
                  && GET_MODE (x4) == E_SImode)
                {
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) == CLOBBER)
                    {
                      x12 = XEXP (x6, 0);
                      operands[0] = x12;
                      if (register_operand (operands[0], E_SImode))
                        {
                          *pnum_clobbers = 3;
                          return 130; /* *pa.md:5428 */
                        }
                    }
                }
            }
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x13 = XEXP (x3, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_VOIDmode))
            return -1;
          x18 = XEXP (x3, 1);
          operands[2] = x18;
          if (!register_operand (operands[2], E_VOIDmode))
            return -1;
          x12 = XEXP (x6, 0);
          operands[3] = x12;
          if (!register_operand (operands[3], E_VOIDmode))
            return -1;
          x7 = XEXP (x6, 1);
          switch (GET_CODE (x7))
            {
            case PLUS:
              x10 = XEXP (x7, 0);
              operands[4] = x10;
              if (!register_operand (operands[4], E_VOIDmode))
                return -1;
              x11 = XEXP (x7, 1);
              operands[5] = x11;
              if (!register_operand (operands[5], E_VOIDmode)
                  || !
#line 9649 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpyaddoperands (operands)))
                return -1;
              return 241; /* *pa.md:9642 */

            case MINUS:
              x10 = XEXP (x7, 0);
              operands[4] = x10;
              if (!register_operand (operands[4], E_VOIDmode))
                return -1;
              x11 = XEXP (x7, 1);
              operands[5] = x11;
              if (!register_operand (operands[5], E_VOIDmode)
                  || !
#line 9707 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpysuboperands (operands)))
                return -1;
              return 243; /* *pa.md:9700 */

            default:
              return -1;
            }

        case NEG:
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x13 = XEXP (x3, 0);
          switch (GET_CODE (x13))
            {
            case REG:
            case SUBREG:
              operands[1] = x13;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != TRAP_IF)
                return -1;
              x12 = XEXP (x6, 0);
              if (GET_CODE (x12) != NE)
                return -1;
              x19 = XEXP (x12, 0);
              if (GET_CODE (x19) != NEG)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != SIGN_EXTEND)
                return -1;
              x21 = XEXP (x12, 1);
              if (GET_CODE (x21) != SIGN_EXTEND)
                return -1;
              x22 = XEXP (x21, 0);
              if (GET_CODE (x22) != NEG)
                return -1;
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x23 = XEXP (x20, 0);
              if (!rtx_equal_p (x23, operands[1]))
                return -1;
              x24 = XEXP (x22, 0);
              if (!rtx_equal_p (x24, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern58 (x1, E_DImode, E_TImode) != 0)
                    return -1;
                  return 141; /* *pa.md:5920 */

                case E_SImode:
                  if (pattern58 (x1, E_SImode, E_DImode) != 0)
                    return -1;
                  return 143; /* negvsi2 */

                default:
                  return -1;
                }

            case ABS:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              switch (pattern38 (x1))
                {
                case 0:
                  if (!
#line 6251 "../../gcc/config/pa/pa.md"
((! TARGET_SOFT_FLOAT && TARGET_PA_20
    && ! reg_overlap_mentioned_p (operands[2], operands[1]))))
                    return -1;
                  return 168; /* *pa.md:6247 */

                case 1:
                  if (!
#line 6270 "../../gcc/config/pa/pa.md"
((! TARGET_SOFT_FLOAT && TARGET_PA_20
    && ! reg_overlap_mentioned_p (operands[2], operands[1]))))
                    return -1;
                  return 169; /* *pa.md:6266 */

                default:
                  return -1;
                }

            case MULT:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              switch (pattern40 (x1))
                {
                case 0:
                  if (!
#line 6311 "../../gcc/config/pa/pa.md"
((!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros
    && ! (reg_overlap_mentioned_p (operands[3], operands[1])
          || reg_overlap_mentioned_p (operands[3], operands[2])))))
                    return -1;
                  return 172; /* *pa.md:6305 */

                case 1:
                  if (!
#line 6335 "../../gcc/config/pa/pa.md"
((!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros
    && ! (reg_overlap_mentioned_p (operands[3], operands[1])
          || reg_overlap_mentioned_p (operands[3], operands[2])))))
                    return -1;
                  return 173; /* *pa.md:6329 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LABEL_REF:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x13 = XEXP (x3, 0);
              operands[1] = x13;
              if (
#line 7065 "../../gcc/config/pa/pa.md"
(!TARGET_PA_20))
                return 197; /* lcla1 */
              if (!
#line 7080 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
                return -1;
              return 198; /* lcla2 */

            case PC:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x12 = XEXP (x6, 0);
              operands[0] = x12;
              x7 = XEXP (x6, 1);
              switch (GET_CODE (x7))
                {
                case PLUS:
                  if (GET_MODE (x7) != E_SImode)
                    return -1;
                  x13 = XEXP (x3, 0);
                  operands[3] = x13;
                  if (!ireg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x7, 0);
                  operands[1] = x10;
                  if (!ireg_operand (operands[1], E_SImode))
                    return -1;
                  x11 = XEXP (x7, 1);
                  operands[2] = x11;
                  if (!ireg_or_int5_operand (operands[2], E_SImode)
                      || !
#line 9531 "../../gcc/config/pa/pa.md"
((reload_completed && operands[0] == operands[1]) || operands[0] == operands[2]))
                    return -1;
                  return 236; /* *pa.md:9526 */

                case CONST_INT:
                case REG:
                  operands[1] = x7;
                  x13 = XEXP (x3, 0);
                  operands[2] = x13;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SFmode:
                      if (!ireg_operand (operands[0], E_SFmode)
                          || !ireg_or_int5_operand (operands[1], E_SFmode)
                          || !
#line 9554 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 237; /* *pa.md:9550 */

                    case E_SImode:
                      if (!ireg_operand (operands[0], E_SImode)
                          || !ireg_or_int5_operand (operands[1], E_SImode)
                          || !
#line 9577 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 238; /* *pa.md:9573 */

                    case E_HImode:
                      if (!ireg_operand (operands[0], E_HImode)
                          || !ireg_or_int5_operand (operands[1], E_HImode)
                          || !
#line 9600 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 239; /* *pa.md:9596 */

                    case E_QImode:
                      if (!ireg_operand (operands[0], E_QImode)
                          || !ireg_or_int5_operand (operands[1], E_QImode)
                          || !
#line 9623 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 240; /* *pa.md:9619 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x13 = XEXP (x3, 0);
          switch (GET_CODE (x13))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              if (pnum_clobbers != NULL)
                {
                  res = recog_15 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (!movb_comparison_operator (x13, E_VOIDmode))
                return -1;
              operands[2] = x13;
              x25 = XEXP (x13, 1);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x4 = XEXP (x2, 0);
              if (GET_CODE (x4) != PC)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x14 = XEXP (x13, 0);
              operands[1] = x14;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x12 = XEXP (x6, 0);
              operands[0] = x12;
              if (!reg_before_reload_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x6, 1);
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              x18 = XEXP (x3, 1);
              switch (GET_CODE (x18))
                {
                case LABEL_REF:
                  x26 = XEXP (x3, 2);
                  if (GET_CODE (x26) != PC)
                    return -1;
                  x27 = XEXP (x18, 0);
                  operands[3] = x27;
                  return 234; /* *pa.md:9383 */

                case PC:
                  x26 = XEXP (x3, 2);
                  if (GET_CODE (x26) != LABEL_REF)
                    return -1;
                  x28 = XEXP (x26, 0);
                  operands[3] = x28;
                  return 235; /* *pa.md:9455 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (XINT (x3, 1))
            {
            case 0:
              if (pnum_clobbers == NULL
                  || pattern44 (x3) != 0)
                return -1;
              x4 = XEXP (x2, 0);
              if (GET_CODE (x4) != REG
                  || REGNO (x4) != 29
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x12 = XEXP (x6, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 3;
              return 251; /* *$$sh_func_adrs */

            case 13:
              if (GET_MODE (x3) != E_BLKmode)
                return -1;
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              if (!pmode_register_operand (operands[1], E_VOIDmode))
                return -1;
              x29 = XVECEXP (x3, 0, 0);
              if (!rtx_equal_p (x29, operands[0]))
                return -1;
              if (
#line 10358 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && TARGET_COHERENT_LDCW))
                return 264; /* *memory_barrier_coherent */
              return 265; /* *memory_barrier_32 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern9 (x6, 2, USE) != 0)
        return -1;
      if (
#line 6969 "../../gcc/config/pa/pa.md"
(pa_can_use_return_insn ()))
        return 193; /* return */
      return 194; /* return_internal */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET
          || pattern41 (x6) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      if (!call_operand_address (operands[0], E_VOIDmode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x7 = XEXP (x6, 1);
      x11 = XEXP (x7, 1);
      x30 = XEXP (x11, 0);
      operands[2] = x30;
      if (!
#line 8551 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 218; /* call_mcount_nonpic */

    default:
      return -1;
    }
}

static int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case DIV:
          if (pattern14 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 131; /* *pa.md:5559 */

        case UDIV:
          if (pattern14 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 132; /* *pa.md:5620 */

        case MOD:
          if (pattern15 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 133; /* *pa.md:5678 */

        case UMOD:
          if (pattern15 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 134; /* *pa.md:5734 */

        case MEM:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != PLUS)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MULT)
            return -1;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XEXP (x5, 0);
          operands[0] = x11;
          x12 = XEXP (x7, 0);
          operands[1] = x12;
          x13 = XEXP (x9, 0);
          operands[2] = x13;
          x14 = XEXP (x10, 0);
          operands[3] = x14;
          switch (XWINT (x6, 0))
            {
            case 4L:
              if (pattern57 (x3, E_SImode) != 0
                  || !
#line 7267 "../../gcc/config/pa/pa.md"
(flag_pic))
                return -1;
              return 204; /* casesi32p */

            case 8L:
              if (pattern57 (x3, E_DImode) != 0)
                return -1;
              return 205; /* casesi64p */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x4 = XEXP (x3, 0);
          if (!ordered_comparison_operator (x4, E_VOIDmode))
            return -1;
          operands[2] = x4;
          if (pattern32 (x1) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XEXP (x4, 0);
          x11 = XEXP (x5, 0);
          operands[0] = x11;
          if (!reg_before_reload_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x5, 1);
          operands[1] = x6;
          if (!int5_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x3, 1);
          x16 = XEXP (x15, 0);
          operands[3] = x16;
          x14 = XEXP (x10, 0);
          operands[4] = x14;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x17 = XEXP (x9, 1);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[0]))
            return -1;
          x19 = XEXP (x17, 1);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          x13 = XEXP (x9, 0);
          if (!rtx_equal_p (x13, operands[0]))
            return -1;
          return 233; /* decrement_and_branch_until_zero */

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || pattern24 (x1, 1, CLOBBER) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          x14 = XEXP (x10, 0);
          if (GET_CODE (x14) != REG
              || GET_MODE (x14) != E_SImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x20 = XVECEXP (x3, 0, 0);
          operands[1] = x20;
          switch (XINT (x3, 1))
            {
            case 4:
              if (REGNO (x14) != 27
                  || !tgd_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 253; /* tgd_load */

            case 10:
              if (REGNO (x14) != 19
                  || !tgd_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 254; /* tgd_load_pic */

            case 5:
              if (REGNO (x14) != 27
                  || !tld_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 255; /* tld_load */

            case 11:
              if (REGNO (x14) != 19
                  || !tld_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 256; /* tld_load_pic */

            case 8:
              if (REGNO (x14) != 27
                  || !tie_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 259; /* tie_load */

            case 12:
              if (REGNO (x14) != 19
                  || !tie_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              return 260; /* tie_load_pic */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER
          || pattern17 (x1, 1, 2, USE) != 0
          || !
#line 6998 "../../gcc/config/pa/pa.md"
(!TARGET_NO_SPACE_REGS
   && !TARGET_PA_20
   && flag_pic && crtl->calls_eh_return))
        return -1;
      return 195; /* return_external_pic */

    case CALL:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET
          || pattern33 (x1) != 0)
        return -1;
      x21 = XEXP (x8, 0);
      operands[0] = x21;
      if (!call_operand_address (operands[0], E_VOIDmode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x17 = XEXP (x9, 1);
      x19 = XEXP (x17, 1);
      x22 = XEXP (x19, 0);
      operands[2] = x22;
      if (!
#line 8551 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
        return -1;
      return 218; /* call_mcount_nonpic */

    case UNSPEC_VOLATILE:
      if (pnum_clobbers == NULL
          || XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4)
        return -1;
      x23 = XVECEXP (x2, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != USE
          || pattern17 (x1, 29, 28, USE) != 0)
        return -1;
      *pnum_clobbers = 7;
      return 250; /* outline_epilogue_call */

    default:
      return -1;
    }
}

static int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (pattern28 (x1) != 0)
            return -1;
          x6 = XEXP (x2, 0);
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode)
              || pattern45 (x1) != 0)
            return -1;
          return 73; /* clrmemsi_prereload */

        case MULT:
          if (pattern22 (x5) != 0
              || pattern51 (x1, 25) != 0)
            return -1;
          return 130; /* *pa.md:5428 */

        case CALL:
          if (pattern29 (x1) != 0
              || pattern50 (x1, USE, 19, 2) != 0)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          switch (pattern52 (x2))
            {
            case 0:
              if (XWINT (x9, 0) != 0L)
                return -1;
              x10 = XEXP (x5, 1);
              operands[2] = x10;
              if (!
#line 8038 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                return -1;
              return 214; /* *call_val_symref_pic_post_reload */

            case 1:
              if (XWINT (x9, 0) != 1L)
                return -1;
              x10 = XEXP (x5, 1);
              operands[1] = x10;
              return 217; /* *call_val_reg_pic_post_reload */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 0
              || pattern44 (x5) != 0
              || pattern51 (x1, 22) != 0)
            return -1;
          return 251; /* *$$sh_func_adrs */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (pattern16 (x4, 2, CLOBBER) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x8) != USE)
        return -1;
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[0] = x7;
          if (!call_operand_address (operands[0], E_VOIDmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x3 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x3))
            {
            case CLOBBER:
              if (pattern54 (x1, 0) != 0
                  || !
#line 7524 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                return -1;
              return 208; /* *call_symref_pic_post_reload */

            case SET:
              if (pattern41 (x3) != 0
                  || pattern64 (x1) != 0)
                return -1;
              x11 = XEXP (x3, 1);
              x12 = XEXP (x11, 1);
              x13 = XEXP (x12, 0);
              operands[2] = x13;
              x14 = XVECEXP (x1, 0, 3);
              x15 = XEXP (x14, 0);
              operands[3] = x15;
              if (!
#line 8570 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                return -1;
              return 219; /* call_mcount_pic */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x7) != 22
              || GET_MODE (x7) != E_SImode)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER
              || pattern54 (x1, 1) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          operands[0] = x5;
          return 211; /* *call_reg_pic_post_reload */

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL
          || XWINT (x2, 0) != 1L
          || pattern23 (x1, 1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x16 = XEXP (x4, 0);
      operands[0] = x16;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      operands[1] = x15;
      if (!pmode_register_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!pmode_register_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
        {
          *pnum_clobbers = 1;
          return 245; /* dcacheflushsi */
        }
      if (!
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
        return -1;
      *pnum_clobbers = 1;
      return 246; /* dcacheflushdi */

    default:
      return -1;
    }
}

static int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[2] = x2;
      if (comparison_operator (operands[2], E_CCFPmode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == REG
              && REGNO (x3) == 0
              && GET_MODE (x3) == E_CCFPmode)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (reg_or_0_operand (operands[0], E_SFmode)
                      && reg_or_0_operand (operands[1], E_SFmode)
                      && 
#line 704 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                    return 1; /* *pa.md:699 */
                  break;

                case E_DFmode:
                  if (reg_or_0_operand (operands[0], E_DFmode)
                      && reg_or_0_operand (operands[1], E_DFmode)
                      && 
#line 714 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                    return 2; /* *pa.md:709 */
                  break;

                default:
                  break;
                }
            }
        }
      if (!ordered_comparison_operator (x2, E_SImode))
        return -1;
      operands[3] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!arith11_operand (operands[2], E_SImode))
        return -1;
      return 5; /* scc */

    case NEG:
      return recog_10 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_8 (x1, insn, pnum_clobbers);

    case SMIN:
      if (pattern0 (x1) != 0)
        return -1;
      return 19; /* sminsi3 */

    case UMIN:
      if (pattern0 (x1) != 0)
        return -1;
      return 20; /* uminsi3 */

    case SMAX:
      if (pattern0 (x1) != 0)
        return -1;
      return 21; /* smaxsi3 */

    case UMAX:
      if (pattern0 (x1) != 0)
        return -1;
      return 22; /* umaxsi3 */

    case ABS:
      return recog_12 (x1, insn, pnum_clobbers);

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 26; /* bswaphi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 27; /* bswapsi2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_14 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 2)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern47 (x2, E_SImode) != 0
                  || !
#line 2673 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && flag_pic))
                return -1;
              return 55; /* *pa.md:2669 */

            case E_DImode:
              if (pattern47 (x2, E_DImode) != 0
                  || !
#line 2684 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && TARGET_64BIT
   && flag_pic))
                return -1;
              return 56; /* *pa.md:2680 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern36 (x2, E_SImode) != 0
                  || !
#line 2779 "../../gcc/config/pa/pa.md"
(!pa_is_function_label_plus_const (operands[2])))
                return -1;
              return 60; /* *pa.md:2775 */

            case E_DImode:
              if (pattern36 (x2, E_DImode) != 0)
                return -1;
              return 85; /* *pa.md:4349 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_11 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !move_src_operand (operands[1], E_QImode)
              || !
#line 4640 "../../gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
            return -1;
          return 91; /* *pa.md:4636 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          if (move_src_operand (operands[1], E_QImode)
              && 
#line 4658 "../../gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
            return 92; /* *pa.md:4654 */
          if (!move_src_operand (operands[1], E_HImode)
              || !
#line 4676 "../../gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
            return -1;
          return 93; /* *pa.md:4672 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 94; /* extendhisi2 */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 96; /* extendqisi2 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          return 95; /* extendqihi2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 4794 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 97; /* extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 4803 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 98; /* truncdfsf2 */

    case FLOAT:
      return recog_13 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 4912 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 105; /* fix_truncsfsi2 */

        case 1:
          if (!
#line 4920 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 106; /* fix_truncdfsi2 */

        case 2:
          if (!
#line 4928 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 107; /* fix_truncsfdi2 */

        case 3:
          if (!
#line 4936 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 108; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern19 (x2, E_DFmode))
            {
            case 0:
              if (!
#line 4944 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 109; /* floatunssidf2_pa20 */

            case 1:
              if (!
#line 4968 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 112; /* floatunsdidf2 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern19 (x2, E_SFmode))
            {
            case 0:
              if (!
#line 4952 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 110; /* floatunssisf2_pa20 */

            case 1:
              if (!
#line 4960 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 111; /* floatunsdisf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 4976 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 113; /* fixuns_truncsfsi2 */

        case 1:
          if (!
#line 4984 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 114; /* fixuns_truncdfsi2 */

        case 2:
          if (!
#line 4992 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 115; /* fixuns_truncsfdi2 */

        case 3:
          if (!
#line 5000 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 116; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          if (pattern11 (x2, E_DImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x5) != E_DImode)
                return -1;
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 5405 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_DISABLE_FPREGS && ! TARGET_SOFT_FLOAT))
                return -1;
              return 128; /* umulsidi3 */

            case CONST_INT:
            case CONST_DOUBLE:
              operands[2] = x5;
              if (!uint32_operand (operands[2], E_DImode)
                  || !
#line 5414 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_DISABLE_FPREGS && ! TARGET_SOFT_FLOAT && !TARGET_64BIT))
                return -1;
              return 129; /* *pa.md:5410 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern8 (x2))
            {
            case 0:
              if (!
#line 6039 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 150; /* muldf3 */

            case 1:
              if (!
#line 6049 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 151; /* mulsf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!and_operand (operands[2], E_SImode))
            return -1;
          return 135; /* andsi3 */

        case NOT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 136; /* *pa.md:5804 */

        case ROTATE:
          if (pattern26 (x2) != 0
              || !
#line 6514 "../../gcc/config/pa/pa.md"
(INTVAL (operands[1]) == -2))
            return -1;
          return 182; /* vdepi_and */

        case ASHIFT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!const_int_operand (operands[3], E_SImode)
              || !
#line 6952 "../../gcc/config/pa/pa.md"
(exact_log2 (1 + (INTVAL (operands[3]) >> (INTVAL (operands[2]) & 31))) > 0))
            return -1;
          return 192; /* *pa.md:6947 */

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 144; /* *pa.md:5969 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 145; /* one_cmplsi2 */

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern8 (x2))
        {
        case 0:
          if (!
#line 6059 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 152; /* divdf3 */

        case 1:
          if (!
#line 6068 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 153; /* divsf3 */

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 6173 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 160; /* sqrtdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6181 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 161; /* sqrtsf2 */

        default:
          return -1;
        }

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x10 = XEXP (x2, 2);
      operands[3] = x10;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern42 (x2, E_DFmode) != 0
                  || !
#line 6194 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 162; /* fmadf4 */

            case E_SFmode:
              if (pattern42 (x2, E_SFmode) != 0
                  || !
#line 6204 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 163; /* fmasf4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern43 (x2, E_DFmode) != 0
                  || !
#line 6215 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 164; /* fnmadf4 */

            case E_SFmode:
              if (pattern43 (x2, E_SFmode) != 0
                  || !
#line 6225 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 165; /* fnmasf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (memory_operand (operands[1], E_SImode))
        {
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) == CONST_INT)
            {
              switch (XWINT (x5, 0))
                {
                case 24L:
                  return 174; /* *pa.md:6357 */

                case 16L:
                  return 175; /* *pa.md:6366 */

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!shift5_operand (operands[2], E_SImode))
        return -1;
      return 185; /* lshrsi3 */

    case ASHIFT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (pattern27 (x5))
        {
        case 0:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 178; /* *pa.md:6447 */

        case 1:
          if (arith5_operand (operands[1], E_SImode))
            return 179; /* zvdep32 */
          if (!lhs_lshift_cint_operand (operands[1], E_SImode))
            return -1;
          return 180; /* zvdep_imm32 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (pattern27 (x5))
        {
        case 0:
          return 183; /* *pa.md:6662 */

        case 1:
          return 184; /* vextrs32 */

        default:
          return -1;
        }

    case PLUS:
    case IOR:
    case XOR:
      return recog_9 (x1, insn, pnum_clobbers);

    case ROTATERT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!shift5_operand (operands[2], E_SImode))
        return -1;
      return 188; /* rotrsi3 */

    case ROTATE:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 189; /* *rotlsi3_internal */

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (pattern21 (x1) == 0
          && 
#line 8998 "../../gcc/config/pa/pa.md"
(UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 32))
        return 227; /* extzv_32 */
      if (XWINT (x5, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 228; /* *pa.md:9004 */

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (pattern21 (x1) == 0
          && 
#line 9098 "../../gcc/config/pa/pa.md"
(UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 32))
        return 229; /* extv_32 */
      if (XWINT (x5, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 230; /* *pa.md:9104 */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 3
          || GET_MODE (x2) != E_SImode)
        return -1;
      x11 = XVECEXP (x2, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 258; /* tp_load */

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_20 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return recog_17 (x1, insn, pnum_clobbers);

        case 8:
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case SET:
              x4 = XEXP (x3, 1);
              if (GET_CODE (x4) != MEM
                  || GET_MODE (x4) != E_BLKmode)
                return -1;
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_BLKmode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER
                  || pattern49 (x1, USE, CLOBBER) != 0)
                return -1;
              x7 = XEXP (x5, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_SImode)
                  || pattern3 (x1) != 0)
                return -1;
              return 71; /* cpymemsi_prereload */

            case CONST_INT:
              if (XWINT (x3, 0) != 2L)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern13 (x6, 2) != 0
                  || pattern49 (x1, CLOBBER, USE) != 0
                  || pattern56 (x1) != 0)
                return -1;
              x9 = XVECEXP (x1, 0, 7);
              x10 = XEXP (x9, 0);
              operands[5] = x10;
              switch (GET_MODE (operands[5]))
                {
                case E_SImode:
                  if (!scratch_operand (operands[5], E_SImode)
                      || !
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                    return -1;
                  return 247; /* icacheflushsi */

                case E_DImode:
                  if (!scratch_operand (operands[5], E_DImode)
                      || !
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                    return -1;
                  return 248; /* icacheflushdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 9:
          x3 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x3) != SET)
            return -1;
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_BLKmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x11) != CLOBBER)
            return -1;
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != CLOBBER)
            return -1;
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != CLOBBER)
            return -1;
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != USE)
            return -1;
          x9 = XVECEXP (x1, 0, 7);
          if (GET_CODE (x9) != USE)
            return -1;
          x15 = XVECEXP (x1, 0, 8);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x16 = XEXP (x6, 0);
          operands[2] = x16;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x17 = XEXP (x11, 0);
          operands[3] = x17;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x18 = XEXP (x12, 0);
          operands[6] = x18;
          if (!register_operand (operands[6], E_SImode))
            return -1;
          x19 = XEXP (x14, 0);
          operands[4] = x19;
          if (!arith14_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x9, 0);
          operands[5] = x10;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x20 = XEXP (x13, 0);
          if (!rtx_equal_p (x20, operands[0]))
            return -1;
          x21 = XEXP (x2, 0);
          if (!rtx_equal_p (x21, operands[1])
              || !
#line 3374 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
            return -1;
          return 72; /* cpymemsi_postreload */

        case 5:
          return recog_19 (x1, insn, pnum_clobbers);

        case 6:
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case SET:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != CLOBBER)
                return -1;
              x4 = XEXP (x3, 1);
              switch (GET_CODE (x4))
                {
                case CONST_INT:
                  if (pattern28 (x1) != 0)
                    return -1;
                  x2 = XVECEXP (x1, 0, 5);
                  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x5 = XEXP (x3, 0);
                  x7 = XEXP (x5, 0);
                  operands[0] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x16 = XEXP (x6, 0);
                  operands[1] = x16;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x12 = XVECEXP (x1, 0, 3);
                  x18 = XEXP (x12, 0);
                  operands[2] = x18;
                  if (!arith14_operand (operands[2], E_SImode))
                    return -1;
                  x13 = XVECEXP (x1, 0, 4);
                  x20 = XEXP (x13, 0);
                  operands[3] = x20;
                  if (!const_int_operand (operands[3], E_SImode))
                    return -1;
                  x17 = XEXP (x11, 0);
                  if (!rtx_equal_p (x17, operands[0])
                      || !
#line 3676 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
                    return -1;
                  return 74; /* clrmemsi_postreload */

                case DIV:
                  if (pattern30 (x1) != 0)
                    return -1;
                  return 131; /* *pa.md:5559 */

                case UDIV:
                  if (pattern30 (x1) != 0)
                    return -1;
                  return 132; /* *pa.md:5620 */

                case MOD:
                  if (pattern31 (x1) != 0)
                    return -1;
                  return 133; /* *pa.md:5678 */

                case UMOD:
                  if (pattern31 (x1) != 0)
                    return -1;
                  return 134; /* *pa.md:5734 */

                case CALL:
                  if (pattern29 (x1) != 0
                      || pattern5 (x1) != 0)
                    return -1;
                  switch (pattern63 (x1))
                    {
                    case 0:
                      if (!
#line 7976 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 213; /* call_val_symref_pic */

                    case 1:
                      return 216; /* call_val_reg_pic */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case CALL:
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_SImode
                  || pattern6 (x1) != 0)
                return -1;
              switch (pattern61 (x1))
                {
                case 0:
                  if (!
#line 7467 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                    return -1;
                  return 207; /* call_symref_pic */

                case 1:
                  return 210; /* call_reg_pic */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x3, 0) != 1L)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern13 (x6, 1) != 0)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != USE)
                return -1;
              x12 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x12) != USE)
                return -1;
              x13 = XVECEXP (x1, 0, 4);
              if (GET_CODE (x13) != USE)
                return -1;
              x2 = XVECEXP (x1, 0, 5);
              if (GET_CODE (x2) != CLOBBER)
                return -1;
              x17 = XEXP (x11, 0);
              operands[0] = x17;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              x18 = XEXP (x12, 0);
              operands[1] = x18;
              if (!pmode_register_operand (operands[1], E_VOIDmode))
                return -1;
              x20 = XEXP (x13, 0);
              operands[2] = x20;
              if (!pmode_register_operand (operands[2], E_VOIDmode))
                return -1;
              x21 = XEXP (x2, 0);
              operands[3] = x21;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (!scratch_operand (operands[3], E_SImode)
                      || !
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                    return -1;
                  return 245; /* dcacheflushsi */

                case E_DImode:
                  if (!scratch_operand (operands[3], E_DImode)
                      || !
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                    return -1;
                  return 246; /* dcacheflushdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          return recog_18 (x1, insn, pnum_clobbers);

        case 4:
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != USE)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (pattern10 (x3))
            {
            case 0:
              x5 = XEXP (x3, 0);
              x7 = XEXP (x5, 0);
              switch (GET_CODE (x7))
                {
                case CONST_INT:
                case CONST_DOUBLE:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x7;
                  if (!call_operand_address (operands[0], E_VOIDmode))
                    return -1;
                  x4 = XEXP (x3, 1);
                  operands[1] = x4;
                  x6 = XVECEXP (x1, 0, 1);
                  switch (GET_CODE (x6))
                    {
                    case CLOBBER:
                      x16 = XEXP (x6, 0);
                      if (GET_CODE (x16) != REG
                          || REGNO (x16) != 1
                          || GET_MODE (x16) != E_SImode)
                        return -1;
                      x18 = XEXP (x12, 0);
                      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                        return -1;
                      x11 = XVECEXP (x1, 0, 2);
                      switch (pattern55 (x11))
                        {
                        case 0:
                          if (!
#line 7448 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                            return -1;
                          return 206; /* call_symref */

                        case 1:
                          if (!
#line 8753 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                            return -1;
                          return 221; /* sibcall_internal_symref */

                        default:
                          return -1;
                        }

                    case SET:
                      if (pattern33 (x1) != 0)
                        return -1;
                      x18 = XEXP (x12, 0);
                      if (GET_CODE (x18) != REG
                          || REGNO (x18) != 19
                          || GET_MODE (x18) != E_SImode)
                        return -1;
                      x22 = XEXP (x6, 1);
                      x23 = XEXP (x22, 1);
                      x24 = XEXP (x23, 0);
                      operands[2] = x24;
                      if (!
#line 8605 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 220; /* *call_mcount_pic_post_reload */

                    default:
                      return -1;
                    }

                case REG:
                  if (REGNO (x7) != 22
                      || GET_MODE (x7) != E_SImode)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != CLOBBER
                      || pattern17 (x1, 1, 2, CLOBBER) != 0)
                    return -1;
                  x18 = XEXP (x12, 0);
                  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x4 = XEXP (x3, 1);
                  operands[0] = x4;
                  return 209; /* call_reg */

                default:
                  return -1;
                }

            case 1:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern9 (x6, 1, CLOBBER) != 0)
                return -1;
              x18 = XEXP (x12, 0);
              if (GET_CODE (x18) != CONST_INT)
                return -1;
              switch (pattern52 (x3))
                {
                case 0:
                  if (XWINT (x18, 0) != 0L)
                    return -1;
                  x4 = XEXP (x3, 1);
                  x25 = XEXP (x4, 1);
                  operands[2] = x25;
                  x11 = XVECEXP (x1, 0, 2);
                  switch (pattern55 (x11))
                    {
                    case 0:
                      if (!
#line 7936 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 212; /* call_val_symref */

                    case 1:
                      if (!
#line 8840 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 222; /* sibcall_value_internal_symref */

                    default:
                      return -1;
                    }

                case 1:
                  x11 = XVECEXP (x1, 0, 2);
                  if (pattern16 (x11, 2, CLOBBER) != 0
                      || XWINT (x18, 0) != 1L)
                    return -1;
                  x4 = XEXP (x3, 1);
                  x25 = XEXP (x4, 1);
                  operands[1] = x25;
                  return 215; /* call_val_reg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 7:
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case CONST_INT:
              if (pnum_clobbers == NULL
                  || XWINT (x3, 0) != 2L
                  || pattern23 (x1, 2) != 0
                  || pattern56 (x1) != 0)
                return -1;
              if (
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                {
                  *pnum_clobbers = 1;
                  return 247; /* icacheflushsi */
                }
              if (!
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 248; /* icacheflushdi */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x3, 0) != 1
                  || XINT (x3, 1) != 3)
                return -1;
              x26 = XVECEXP (x3, 0, 0);
              if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x16 = XEXP (x6, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 31
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != CLOBBER)
                return -1;
              x17 = XEXP (x11, 0);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 22
                  || GET_MODE (x17) != E_SImode)
                return -1;
              x12 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x12) != CLOBBER)
                return -1;
              x18 = XEXP (x12, 0);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 21
                  || GET_MODE (x18) != E_SImode)
                return -1;
              x13 = XVECEXP (x1, 0, 4);
              if (GET_CODE (x13) != CLOBBER)
                return -1;
              x20 = XEXP (x13, 0);
              if (GET_CODE (x20) != REG
                  || REGNO (x20) != 20
                  || GET_MODE (x20) != E_SImode)
                return -1;
              x21 = XEXP (x2, 0);
              if (GET_CODE (x21) != REG
                  || REGNO (x21) != 19
                  || GET_MODE (x21) != E_SImode)
                return -1;
              x19 = XEXP (x14, 0);
              if (GET_CODE (x19) != REG
                  || REGNO (x19) != 1
                  || GET_MODE (x19) != E_SImode)
                return -1;
              return 249; /* outline_prologue_call */

            default:
              return -1;
            }

        case 10:
          x3 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x3) != UNSPEC_VOLATILE
              || XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 4)
            return -1;
          x26 = XVECEXP (x3, 0, 0);
          if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern24 (x1, 29, USE) != 0
              || pattern50 (x1, CLOBBER, 31, 28) != 0)
            return -1;
          x13 = XVECEXP (x1, 0, 4);
          x20 = XEXP (x13, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 22
              || GET_MODE (x20) != E_SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x21 = XEXP (x2, 0);
          if (GET_CODE (x21) != REG
              || REGNO (x21) != 21
              || GET_MODE (x21) != E_SImode)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x19 = XEXP (x14, 0);
          if (GET_CODE (x19) != REG
              || REGNO (x19) != 20
              || GET_MODE (x19) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 7);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 19
              || GET_MODE (x10) != E_SImode)
            return -1;
          x15 = XVECEXP (x1, 0, 8);
          if (GET_CODE (x15) != CLOBBER)
            return -1;
          x27 = XEXP (x15, 0);
          if (GET_CODE (x27) != REG
              || REGNO (x27) != 2
              || GET_MODE (x27) != E_SImode)
            return -1;
          x28 = XVECEXP (x1, 0, 9);
          if (GET_CODE (x28) != CLOBBER)
            return -1;
          x29 = XEXP (x28, 0);
          if (GET_CODE (x29) != REG
              || REGNO (x29) != 1
              || GET_MODE (x29) != E_SImode)
            return -1;
          return 250; /* outline_epilogue_call */

        default:
          return -1;
        }

    case TRAP_IF:
      x30 = XEXP (x1, 0);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x31 = XEXP (x1, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 127; /* trap */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != CONST_INT)
        return -1;
      switch (XINT (x1, 1))
        {
        case 0:
          if (XWINT (x3, 0) != 2L)
            return -1;
          return 199; /* blockage */

        case 3:
          if (pnum_clobbers == NULL
              || XWINT (x3, 0) != 0L)
            return -1;
          *pnum_clobbers = 6;
          return 249; /* outline_prologue_call */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 1)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 7174 "../../gcc/config/pa/pa.md"
(GET_MODE (operands[0]) == word_mode))
        return -1;
      return 202; /* indirect_goto */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 223; /* nop */

    case PREFETCH:
      x30 = XEXP (x1, 0);
      operands[0] = x30;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      x31 = XEXP (x1, 1);
      operands[1] = x31;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x32 = XEXP (x1, 2);
      operands[2] = x32;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 10056 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
        return -1;
      return 252; /* prefetch_20 */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != PARALLEL)
    return NULL;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x3;
          if (!symbolic_operand (operands[1], E_SImode))
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 2801 "../../gcc/config/pa/pa.md"
(! (flag_pic && pic_label_operand (operands[1], SImode))))
            return NULL;
          return gen_split_1 (insn, operands);

        case REG:
        case SUBREG:
          operands[4] = x3;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM)
            return NULL;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != E_SImode)
            return NULL;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != MULT
              || GET_MODE (x8) != E_SImode)
            return NULL;
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x10 = XEXP (x8, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x8, 1);
          operands[1] = x11;
          if (!mem_shadd_operand (operands[1], E_SImode))
            return NULL;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode))
            return NULL;
          x13 = XEXP (x9, 1);
          operands[3] = x13;
          if (!const_int_operand (operands[3], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[5] = x6;
          if (!register_operand (operands[5], E_SImode))
            return NULL;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[4], E_SImode))
                return NULL;
              return gen_split_2 (insn, operands);

            case E_HImode:
              if (!register_operand (operands[4], E_HImode))
                return NULL;
              return gen_split_3 (insn, operands);

            case E_QImode:
              if (!register_operand (operands[4], E_QImode))
                return NULL;
              return gen_split_4 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x14 = XEXP (x3, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (!register_operand (operands[4], E_SImode))
            return NULL;
          if (
#line 5124 "../../gcc/config/pa/pa.md"
(! pa_cint_ok_for_move (UINTVAL (operands[2]))
   && VAL_14_BITS_P (INTVAL (operands[2]) >> 1)))
            return gen_split_7 (insn, operands);
          if (!
#line 5143 "../../gcc/config/pa/pa.md"
(! pa_cint_ok_for_move (UINTVAL (operands[2]))))
            return NULL;
          return gen_split_8 (insn, operands);

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x14 = XEXP (x3, 0);
          switch (GET_CODE (x14))
            {
            case ABS:
              switch (pattern38 (x1))
                {
                case 0:
                  if (!
#line 6261 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                    return NULL;
                  return gen_split_9 (insn, operands);

                case 1:
                  if (!
#line 6280 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                    return NULL;
                  return gen_split_10 (insn, operands);

                default:
                  return NULL;
                }

            case MULT:
              switch (pattern40 (x1))
                {
                case 0:
                  if (!
#line 6324 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
                    return NULL;
                  return gen_split_11 (insn, operands);

                case 1:
                  if (!
#line 6348 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20&& !flag_signed_zeros))
                    return NULL;
                  return gen_split_12 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 8:
      if (pattern4 (x1) != 0
          || !
#line 3294 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed && !flag_peephole2
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)
   && GET_CODE (operands[1]) == MEM
   && register_operand (XEXP (operands[1], 0), SImode)))
        return NULL;
      return gen_split_5 (insn, operands);

    case 5:
      x16 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x16) != CLOBBER)
        return NULL;
      x17 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x17) != USE)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SET:
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x18 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x18) != USE
              || pattern46 (x1) != 0
              || !
#line 3624 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed && !flag_peephole2
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)))
            return NULL;
          return gen_split_6 (insn, operands);

        case CALL:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x19 = XEXP (x4, 1);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return NULL;
          x20 = XEXP (x19, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 2
              || GET_MODE (x20) != E_SImode)
            return NULL;
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != MINUS
              || GET_MODE (x21) != E_SImode)
            return NULL;
          x22 = XEXP (x21, 1);
          if (GET_CODE (x22) != PLUS
              || GET_MODE (x22) != E_SImode)
            return NULL;
          x23 = XEXP (x22, 0);
          if (GET_CODE (x23) != PC)
            return NULL;
          x24 = XEXP (x22, 1);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return NULL;
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 25
              || GET_MODE (x6) != E_SImode)
            return NULL;
          x25 = XEXP (x16, 0);
          if (GET_CODE (x25) != REG
              || REGNO (x25) != 2
              || GET_MODE (x25) != E_SImode
              || pattern64 (x1) != 0)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!call_operand_address (operands[0], E_VOIDmode))
            return NULL;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x26 = XEXP (x21, 0);
          operands[2] = x26;
          x18 = XVECEXP (x1, 0, 3);
          x27 = XEXP (x18, 0);
          operands[3] = x27;
          if (!
#line 8583 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case 6:
      if (pattern6 (x1) != 0)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      switch (pattern10 (x2))
        {
        case 0:
          switch (pattern61 (x1))
            {
            case 0:
              if (
#line 7487 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_13 (insn, operands);
              if (!
#line 7506 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_14 (insn, operands);

            case 1:
              if (
#line 7664 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_15 (insn, operands);
              if (!
#line 7683 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_16 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          switch (pattern63 (x1))
            {
            case 0:
              if (
#line 7997 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_17 (insn, operands);
              if (!
#line 8018 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_18 (insn, operands);

            case 1:
              if (
#line 8370 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_19 (insn, operands);
              if (!
#line 8391 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_20 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 2)
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != PLUS
          || GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MEM)
        return NULL;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x5, 0);
      if (!rtx_equal_p (x7, operands[0]))
        return NULL;
      x8 = XEXP (x2, 0);
      switch (GET_CODE (x8))
        {
        case ASHIFT:
          if (GET_MODE (x8) != E_SImode)
            return NULL;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != CONST_INT)
            return NULL;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x11 = XEXP (x2, 1);
          operands[2] = x11;
          if (!register_operand (operands[2], E_SImode))
            return NULL;
          switch (XWINT (x9, 0))
            {
            case 2L:
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  if (!register_operand (operands[3], E_SImode)
                      || !
#line 2282 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_1 (insn, operands);

                case E_SFmode:
                  if (!register_operand (operands[3], E_SFmode)
                      || !
#line 4507 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_10 (insn, operands);

                default:
                  return NULL;
                }

            case 3L:
              if (GET_MODE (x5) != E_DFmode
                  || !register_operand (operands[3], E_DFmode)
                  || !
#line 3897 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_6 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          if (!register_operand (x8, E_SImode))
            return NULL;
          x11 = XEXP (x2, 1);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[2] = x11;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              operands[1] = x8;
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  if (!register_operand (operands[3], E_SImode))
                    return NULL;
                  if (
#line 2316 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_2 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!
#line 2333 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_3 (insn, operands);

                case E_DFmode:
                  if (!register_operand (operands[3], E_DFmode))
                    return NULL;
                  if (
#line 3966 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_8 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!
#line 3983 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_9 (insn, operands);

                case E_SFmode:
                  if (!register_operand (operands[3], E_SFmode))
                    return NULL;
                  if (
#line 4541 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_11 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!
#line 4558 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_12 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFT:
              if (GET_MODE (x11) != E_SImode)
                return NULL;
              x12 = XEXP (x11, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              operands[2] = x8;
              x13 = XEXP (x11, 0);
              operands[1] = x13;
              if (!register_operand (operands[1], E_SImode)
                  || GET_MODE (x5) != E_DFmode
                  || !register_operand (operands[3], E_DFmode)
                  || !
#line 3914 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_7 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 8:
          if (pattern4 (x1) != 0
              || !
#line 3328 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)
   && GET_CODE (operands[1]) == MEM
   && register_operand (XEXP (operands[1], 0), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_4 (insn, operands);

        case 5:
          x14 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x14) != SET)
            return NULL;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x16 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x16) != CLOBBER)
            return NULL;
          x17 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x17) != CLOBBER)
            return NULL;
          x18 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x18) != USE)
            return NULL;
          x19 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x19) != USE
              || pattern46 (x1) != 0
              || !
#line 3647 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_5 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
